<template>
  <div class="form-input">
    <label :for="id" v-if="label">{{label}}</label>
    <select
      class="custom-select"
      :id="id"
      v-model="selectedValue"
      @change="onInputChange"
    >
      <option selected disabled value="">{{placeholderText}}</option>
      <option
        v-for="(option, index) in options"
        :key="`option-${index}`"
        :value="option.id"
      >{{option.label}}</option>
    </select>
  </div>
</template>
<script lang="ts">
import Vue from 'vue';
import { Component, Prop, Emit } from 'vue-property-decorator';

interface Option {
  key: string;
  value: string;
}

@Component
export default class FormSelect extends Vue {
  @Prop({ default: null }) options!: Array<Option>

  @Prop({ default: null }) label!: string

  @Prop({ default: null }) value!: string

  @Prop({ default: null }) id!: string

  @Prop({ default: null }) name!: string

  @Prop({ default: null }) placeholder!: string

  private selectedValue = ''

  @Emit('onSelectChange')
  onInputChange(): string {
    return this.selectedValue;
  }

  get placeholderText(): string {
    return this.placeholder;
  }
}
</script>
